#define ADDRESS_TB_AO_FREQUENCY 6
#define ADDRESS_TB_AO_FRAMES_PER_UPPER_PART 8
#define ADDRESS_TB_AO_ON_FLAG 10
#define ADDRESS_TB_AO_GAP 12
#define ADDRESS_TB_AO_POSITION_H 14
#define ADDRESS_TB_AO_POSITION_V 16
#define ADDRESS_TB_AO_SIZE_H 18
#define ADDRESS_TB_AO_SIZE_V 20
#define ADDRESS_TB_DI_PERIOD 22
#define ADDRESS_TB_DI_FRAMES_PER_UPPER_PART 24
#define ADDRESS_TB_DI_ON_FLAG 26
#define ADDRESS_TB_DI_OFFSET 28
#define ADDRESS_TB_DI_BREAK 30
#define ADDRESS_TB_DI_POSITION_H 32
#define ADDRESS_TB_DI_POSITION_V 34
#define ADDRESS_TB_DI_SIZE_H 36
#define ADDRESS_TB_DI_SIZE_V 38
#define ADDRESS_SBS_AO_FREQUENCY 40
#define ADDRESS_SBS_AO_FRAMES_PER_LEFT_PART 42
#define ADDRESS_SBS_AO_ON_FLAG 44
#define ADDRESS_SBS_AO_GAP 46
#define ADDRESS_SBS_AO_POSITION_H 48
#define ADDRESS_SBS_AO_POSITION_V 50
#define ADDRESS_SBS_AO_RIGHT_EDGE 52
#define ADDRESS_SBS_AO_SIZE_V 54
#define ADDRESS_SBS_DI_PERIOD 56
#define ADDRESS_SBS_DI_FRAMES_PER_LEFT_PART 58
#define ADDRESS_SBS_DI_ON_FLAG 60
#define ADDRESS_SBS_DI_OFFSET 62
#define ADDRESS_SBS_DI_BREAK 64
#define ADDRESS_SBS_DI_POSITION_H 66
#define ADDRESS_SBS_DI_POSITION_V 68
#define ADDRESS_SBS_DI_SIZE_H 70
#define ADDRESS_SBS_DI_SIZE_V 72
#define ADDRESS_FFR_FR_POSITION 74
#define ADDRESS_FFR_FR_PERIOD 76
#define ADDRESS_FFR_FR_FRAMES_PER_VISIBLE_PART 78
#define ADDRESS_FFR_FR_ON_FLAG 80
#define ADDRESS_FFR_FR_OFFSET 82
#define ADDRESS_FFR_FR_BREAK 84
#define ADDRESS_FFR_FR_POSITION_H 86
#define ADDRESS_FFR_FR_POSITION_V 88
#define ADDRESS_FFR_FR_SIZE_H 90
#define ADDRESS_FFR_FR_SIZE_V 92
#define ADDRESS_FFR_SR_POSITION 94
#define ADDRESS_FFR_SR_PERIOD 96
#define ADDRESS_FFR_SR_FRAMES_PER_VISIBLE_PART 98
#define ADDRESS_FFR_SR_ON_FLAG 100
#define ADDRESS_FFR_SR_OFFSET 102
#define ADDRESS_FFR_SR_BREAK 104
#define ADDRESS_FFR_SR_POSITION_H 106
#define ADDRESS_FFR_SR_POSITION_V 108
#define ADDRESS_FFR_SR_SIZE_H 110
#define ADDRESS_FFR_SR_SIZE_V 112



#define DEFAULT_TB_AO_FREQUENCY 1
#define MAX_TB_AO_FREQUENCY 5

#define DEFAULT_TB_AO_FRAMES_PER_UPPER_PART 6
#define MAX_TB_AO_FRAMES_PER_UPPER_PART 24

#define DEFAULT_TB_AO_ON_FLAG 1
#define MAX_TB_AO_ON_FLAG 1

//      MIN_TB_AO_GAP 0
#define DEFAULT_TB_AO_GAP 0
#define MAX_TB_AO_GAP 20

#define MIN_TB_AO_POSITION_H 8
#define DEFAULT_TB_AO_POSITION_H 60
#define MAX_TB_AO_POSITION_H 240

//      MIN_TB_AO_POSITION_V 0
#define DEFAULT_TB_AO_POSITION_V 20
#define MAX_TB_AO_POSITION_V 240

#define MIN_TB_AO_SIZE_H 30
#define DEFAULT_TB_AO_SIZE_H 120
#define MAX_TB_AO_SIZE_H 500

#define MIN_TB_AO_SIZE_V 25
#define DEFAULT_TB_AO_SIZE_V 50
#define MAX_TB_AO_SIZE_V 137

#define DEFAULT_TB_DI_PERIOD 1
#define MAX_TB_DI_PERIOD 5

#define DEFAULT_TB_DI_FRAMES_PER_UPPER_PART 140
#define MAX_TB_DI_FRAMES_PER_UPPER_PART 480

#define DEFAULT_TB_DI_ON_FLAG 1
#define MAX_TB_DI_ON_FLAG 1

#define MIN_TB_DI_OFFSET -9
#define DEFAULT_TB_DI_OFFSET 0
#define MAX_TB_DI_OFFSET 9

#define DEFAULT_TB_DI_BREAK 0
#define MAX_TB_DI_BREAK 160

#define MIN_TB_DI_POSITION_H 0
#define DEFAULT_TB_DI_POSITION_H 30
#define MAX_TB_DI_POSITION_H 500

#define MIN_TB_DI_POSITION_V 0
#define DEFAULT_TB_DI_POSITION_V 10
#define MAX_TB_DI_POSITION_V 137

#define MIN_TB_DI_SIZE_H 15
#define DEFAULT_TB_DI_SIZE_H 30
#define MAX_TB_DI_SIZE_H 500

#define MIN_TB_DI_SIZE_V 10
#define DEFAULT_TB_DI_SIZE_V 20
#define MAX_TB_DI_SIZE_V 137


#define DEFAULT_SBS_AO_FREQUENCY 1
#define MAX_SBS_AO_FREQUENCY 5

#define DEFAULT_SBS_AO_FRAMES_PER_LEFT_PART 6
#define MAX_SBS_AO_FRAMES_PER_LEFT_PART 24

#define DEFAULT_SBS_AO_ON_FLAG 1
#define MAX_SBS_AO_ON_FLAG 1

#define MIN_SBS_AO_GAP 5
#define DEFAULT_SBS_AO_GAP 5
#define MAX_SBS_AO_GAP 40

#define MIN_SBS_AO_POSITION_H 8
#define DEFAULT_SBS_AO_POSITION_H 60
#define MAX_SBS_AO_POSITION_H 240

//      MIN_SBS_AO_POSITION_V 0
#define DEFAULT_SBS_AO_POSITION_V 20
#define MAX_SBS_AO_POSITION_V 240

#define MIN_SBS_AO_RIGHT_EDGE 60
#define DEFAULT_SBS_AO_RIGHT_EDGE 70
#define MAX_SBS_RIGHT_EDGE 250
 
#define MIN_SBS_AO_SIZE_V 50
#define DEFAULT_SBS_AO_SIZE_V 100
#define MAX_SBS_AO_SIZE_V 274

#define DEFAULT_SBS_DI_PERIOD 1
#define MAX_SBS_DI_PERIOD 5

#define DEFAULT_SBS_DI_FRAMES_PER_LEFT_PART 140
#define MAX_SBS_DI_FRAMES_PER_LEFT_PART 480

#define DEFAULT_SBS_DI_ON_FLAG 1
#define MAX_SBS_DI_ON_FLAG 1

#define MIN_SBS_DI_OFFSET -9
#define DEFAULT_SBS_DI_OFFSET 0
#define MAX_SBS_DI_OFFSET 9

#define DEFAULT_SBS_DI_BREAK 0
#define MAX_SBS_DI_BREAK 160

#define MIN_SBS_DI_POSITION_H 5
#define DEFAULT_SBS_DI_POSITION_H 15
#define MAX_SBS_DI_POSITION_H 240

//      MIN_SBS_DI_POSITION_V 0
#define DEFAULT_SBS_DI_POSITION_V 20
#define MAX_SBS_DI_POSITION_V 234

#define MIN_SBS_DI_SIZE_H 10
#define DEFAULT_SBS_DI_SIZE_H 15
#define MAX_SBS_DI_SIZE_H 240

#define MIN_SBS_DI_SIZE_V 20
#define DEFAULT_SBS_DI_SIZE_V 40
#define MAX_SBS_DI_SIZE_V 274


#define DEFAULT_FFR_FR_POSITION 0
#define MAX_FFR_FR_POSITION 1

#define DEFAULT_FFR_FR_PERIOD 5
#define MAX_FFR_FR_PERIOD 9

#define DEFAULT_FFR_FR_FRAMES_PER_VISIBLE_PART 6
#define MAX_FFR_FR_FRAMES_PER_VISIBLE_PART 280

#define DEFAULT_FFR_FR_ON_FLAG 1
#define MAX_FFR_FR_ON_FLAG 1
 
#define MIN_FFR_FR_POSITION_H 8
#define DEFAULT_FFR_FR_POSITION_H 90
#define MAX_FFR_FR_POSITION_H 740

#define MIN_FFR_FR_POSITION_V 0
#define DEFAULT_FFR_FR_POSITION_V 30
#define MAX_FFR_FR_POSITION_V 274

#define MIN_FFR_FR_SIZE_H 15
#define DEFAULT_FFR_FR_SIZE_H 30
#define MAX_FFR_FR_SIZE_H 500

#define MIN_FFR_FR_SIZE_V 10
#define DEFAULT_FFR_FR_SIZE_V 20
#define MAX_FFR_FR_SIZE_V 274

#define DEFAULT_FFR_SR_POSITION 1
#define MAX_FFR_SR_POSITION 1

#define DEFAULT_FFR_SR_PERIOD 5
#define MAX_FFR_SR_PERIOD 9

#define DEFAULT_FFR_SR_FRAMES_PER_VISIBLE_PART 6
#define MAX_FFR_SR_FRAMES_PER_VISIBLE_PART 280

#define DEFAULT_FFR_SR_ON_FLAG 1
#define MAX_FFR_SR_ON_FLAG 1
 
#define MIN_FFR_SR_POSITION_H 8
#define DEFAULT_FFR_SR_POSITION_H 150
#define MAX_FFR_SR_POSITION_H 740

#define MIN_FFR_SR_POSITION_V 0
#define DEFAULT_FFR_SR_POSITION_V 100
#define MAX_FFR_SR_POSITION_V 274

#define MIN_FFR_SR_SIZE_H 15
#define DEFAULT_FFR_SR_SIZE_H 30
#define MAX_FFR_SR_SIZE_H 500

#define MIN_FFR_SR_SIZE_V 10
#define DEFAULT_FFR_SR_SIZE_V 20
#define MAX_FFR_SR_SIZE_V 274



#define SYNC_INPUT_DDR DDRD
#define SYNC_INPUT_PORT_IN PIND
#define HSYNC_INPUT PD2
#define VSYNC_INPUT PD3

#define MUX_OUTPUT_DDR DDRD
#define MUX_OUTPUT_PORT_OUT PORTD
#define MUX_OUTPUT PD4

#define KEYBOARD_INPUT_DDR DDRC
#define KEYBOARD_PULL_UP PORTC
#define KEYBOARD_PORT_IN PINC
#define PAGE_KEY PC0
#define SHIFT_KEY PC1
#define LEFT_KEY PC2
#define DOWN_KEY PC3
#define UP_KEY PC4
#define RIGHT_KEY PC5

#define MODE_KEY_INPUT_DDR DDRB
#define MODE_KEY_PULL_UP PORTB
#define MODE_KEY_PORT_IN PINB
#define MODE_KEY PB2

#define NO_SIGNAL_LED_DDR DDRD
#define NO_SIGNAL_LED_PORT_OUT PORTD
#define NO_SIGNAL_LED PD7

#define MODE_LED_DDR DDRB
#define MODE_LED_PORT_OUT PORTB
#define MODE_LED_UP PB0
#define MODE_LED_DOWN PB1

#define PAGE_LED_DDR DDRD
#define PAGE_LED_PORT_OUT PORTD
#define PAGE_LED_LEFT PD1
#define PAGE_LED_RIGHT PD0

